(*XLSDEMO
  Fredi Cobo - Software Consultant         fredcobo@yahoo.com
  Mar/05
  Xls 2.1 demo*)

<*+M2EXTENSIONS*>
<*+M2ADDTYPES*>

MODULE XLSDEMO;

IMPORT IO,xls;

CONST
TITLE= "Sample Worksheet";

VAR
r: CARDINAL;

(*
The 'xls' module has been designed to generate native Excel 2.1 files for
simple reporting and export of data, don't include graphics, macros, etc.
It's very useful to prepare Excel files for email because of their compact
size.

We wil create a sample table with each of the types of fields: label,
cardinal, float and date.

Parameters of write procs:

Eg.

xls.Label(0,                  row with base index 0
          0,                  col with base index 0
          "Hello",            data to be written
          xls.blue,           color used: black,white,red,green,blue,yellow,magenta,cyan
          xls.times,          font used: arial,courier,times,lucida,tahoma
          16,                 size of char in points

          xls.BOLD,           style of text: any combination of  REGULAR
                                                                 BOLD
                                                                 ITALIC
                                                                 UNDERLINE
                                                                 STRIKEOUT

                                              eg. xls.BOLD + xls.ITALIC

          xls.GENERAL);       alignment of text: any combination of GENERAL
                                                                    LEFT
                                                                    CENTER
                                                                    RIGHT
                                                                    FILL

                                                                    LBORDER
                                                                    RBORDER
                                                                    UBORDER
                                                                    BBORDER
                                                                    HBORDERS
                                                                    VBORDERS
                                                                     BORDERS

                                              eg. xls.CENTER + xls.BORDERS


xls.Float() use an extra parameter: decimals

Each write proc eg. xls.Label(), have a partner proc eg. xls.WrLabel() that
preserves the set of parameters in next calls.

Dates must be written as julian: 01-ENE-2000 ---> 36526


MAKE: (XDS 2.45 Modula-2 Oberon Compiler)

xc glist.ob2
xc xls.def
xc xls.mod
xc=m xlsdemo

--------------------------------------------------------------------------------

El modulo 'xls' ha sido diseado para generar archivos Excel 2.1 en formato
nativo. Sirve para reportes simples y exportar datos; no incluye graficos,
macros, etc. Es muy util para preparar archivos Excel a ser enviados por
email dado su tamao compacto.

Crearemos una tabla de muestra con cada uno de los tipos de datos: cadenas de
caracteres, cardinales, reales y fechas.

Parametros de los procedimientos para escritura:

Ej.

xls.Label(0,                  fila con base cero
          0,                  columna con base cero
          "Hello",            dato a ser escrito
          xls.blue,           color usado: black,white,red,green,blue,yellow,magenta,cyan
          xls.times,          font usado: arial,courier,times,lucida,tahoma
          16,                 tamao del caracter en puntos
          xls.BOLD,           estilo del texto: cualquier combinacion de REGULAR
                                                                         BOLD
                                                                         ITALIC
                                                                         UNDERLINE
                                                                         STRIKEOUT

                                                ej. xls.BOLD + xls.ITALIC

          xls.GENERAL);       alineamiento del texo: cualquier combinacion de GENERAL
                                                                              LEFT
                                                                              CENTER
                                                                              RIGHT
                                                                              FILL

                                                                              LBORDER
                                                                              RBORDER
                                                                              UBORDER
                                                                              BBORDER
                                                                              HBORDERS
                                                                              VBORDERS
                                                                               BORDERS

                                                     ej. xls.CENTER + xls.BORDERS


xls.Float() usa un parametro extra: decimales

Cada procedimiento de escritura ej. xls.Label(), tiene un procedimiento amigo
ej. xls.WrLabel() que preserva el juego de parametros en las siguientes
llamadas.

Las fechas deben ser escritas como julianas: 01-ENE-2000 ---> 36526


MAKE: (XDS 2.45 Modula-2 Oberon Compiler)

xc glist.ob2
xc xls.def
xc xls.mod
xc=m xlsdemo

--------------------------------------------------------------------------------
*)



  PROCEDURE Header; (*header of table / cabecera de la tabla*)
  BEGIN
    xls.Width(0,0,26); (*width of a range of cells / ancho de un rango de celdas*)
    xls.Width(1,1,14);
    xls.Width(2,3,10);

    xls.Label(0,0,TITLE,xls.blue,xls.times,16,xls.BOLD,xls.GENERAL);

    xls.  Label(2,0,"Name"         ,xls.red,xls.tahoma,12,xls.REGULAR,xls.BORDERS);
    xls.WrLabel(2,1,"Date of birth" );
    xls.WrLabel(2,2,"Age"           );
    xls.WrLabel(2,3,"Salary"        );
  END Header;

  PROCEDURE Data(name  : ARRAY OF CHAR;
                 date  : CARDINAL;
                 age   : CARDINAL;
                 salary: LONGREAL);
  BEGIN
    xls.Label   (r,0,name  ,xls.black,xls.arial,10,xls.REGULAR,xls.GENERAL  );
    xls.Date    (r,1,date  ,xls.black,xls.arial,10,xls.REGULAR,xls.GENERAL  );
    xls.Cardinal(r,2,age   ,xls.black,xls.arial,10,xls.REGULAR,xls.GENERAL  );
    xls.Float   (r,3,salary,xls.black,xls.arial,10,xls.REGULAR,xls.GENERAL,2);

    INC(r)
  END Data;

BEGIN
  xls.Create("demo",0);  (*create file 'demo.xls' with no password, password 1: onegroup, password 2: xantia*)
                         (*se crea el archivo 'demo.xls' sin clave, clave 1: onegroup, clave 2: xantia*)

  Header;

  r:=3;
  Data("John"  ,36526, 4,   0.00);
  Data("Peter" ,22274,44,1250.35);
  Data("Glenda",27454,30,3850.00);
  Data("Freddy",36066, 6,   0.00);

  IF NOT xls.Close() THEN
    xls.Error("Can't write Excel file")
  END;

  IO.WrStr("Ok.")
END XLSDEMO.
